<?php

class ControllerExtensionPaymentHpjWechat extends Controller
{

    private function _redirect($url, $status = 302) {
        header('location: ' . str_replace(array('&amp;', "\n", "\r"), array('&', '', ''), $url), true, $status);
        exit();
    }
    public function index()
    {
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/hpjwechat');
        $this->load->language('extension/payment/hpjwechat');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        
        $data['text_credit_card'] = $this->language->get('text_credit_card');
        $data['text_wait'] = $this->language->get('text_wait');
        
        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['button_back'] = $this->language->get('button_back');
        
        return $this->load->view('extension/payment/hpjwechat', $data);
    }

    public function returns(){
        $sign=$_GET['sign'];
        if(!$sign) $this->throw_err();
        $this->load->model('checkout/order');
        $this->language->load('extension/payment/hpjwechat');
    
        $appid              = $this->config->get('payment_hpjwechat_appid');//测试账户，仅支持一元内支付
        $appsecret          = $this->config->get('payment_hpjwechat_appsecret');//测试账户，仅支持一元内支付
        $order_prefix       = $this->config->get('payment_hpjwechat_order_prefix');
        
        $out_trade_no = isset($_REQUEST['order_id'])?$_REQUEST['order_id']:0;
        $OrderNo = $order_id = substr($out_trade_no, strlen($order_prefix));
        $success_status = $this->config->get('payment_hpjwechat_order_succeed_status_id');
        $order_info =  $this->model_checkout_order->getOrder($order_id);

        if(!$order_info) $this->throw_err($order_id);

        $db = DB_PREFIX;
        $result =$this->db->query(
            "select *
	        from `{$db}order`
            where order_id = '{$order_id}'
                 and order_status_id='{$success_status}'
            limit 1;");
        
        if($result->num_rows){
            $this->_redirect($this->url->link('checkout/success', '', 'SSL'));
            return;
        }
        
        //out_trade_order，open_order_id 二选一
        $request=array(
            'appid'     => $appid, //必须的，APPID
        
            'out_trade_order'=> $out_trade_no, //网站订单号(out_trade_order，open_order_id 二选一)
            //'open_order_id'=> $open_order_id, //虎皮椒内部订单号，在下单时会返回，或支付后会异步回调(out_trade_order，open_order_id 二选一)
        
            'time'      => time(),//必须的，当前时间戳，根据此字段判断订单请求是否已超时，防止第三方攻击服务器
            'nonce_str' => str_shuffle(time())//必须的，随机字符串，作用：1.避免服务器缓存，2.防止安全密钥被猜测出来
        );
        
        $request['hash'] =  $this->generate_xh_hash($request,$appsecret);
        
        $url              = $this->config->get('payment_hpjwechat_transaction_url').'/payment/query.html';
        
        try {
            $response     = $this->http_post($url, http_build_query($request));
            $result       = $response?json_decode($response,true):null;
            if(!$result){
                throw new Exception('Internal server error:'.$response,500);
            }
            
            $db = DB_PREFIX;
            $_result =$this->db->query(
                "select *
                from `{$db}order`
                where order_id = '{$order_id}'
                and order_status_id='{$success_status}'
                limit 1;");
            
            if($_result->num_rows){
                $this->cart->clear();
                unset($this->session->data['order_id']);
                $this->session->data['cart']=array();
                $this->_redirect($this->url->link('checkout/success', '', 'SSL'));
                return;
            }
            
            $transaction_id= isset($result['data']['transaction_id'])?$result['data']['transaction_id']:null;
            $message = "Transaction Id:{$transaction_id}";
            
            if(isset($result['errcode'])
            		&&$result['errcode']=='0'
            		&&isset($result['data']['status'])&&$result['data']['status']=='OD'){
                if(method_exists($this->model_checkout_order,'confirm')){
                    $order_info =  $this->model_checkout_order->getOrder($OrderNo);
                    if ($order_info && $order_info['order_status_id']) {
                        $this->model_checkout_order->update($OrderNo, $this->config->get('payment_hpjwechat_order_succeed_status_id'), $message, true);
                    }else{
                        $this->model_checkout_order->confirm($OrderNo, $this->config->get('payment_hpjwechat_order_succeed_status_id'), $message, true);
                    }
                
                }else{
                    $this->model_checkout_order->addOrderHistory($OrderNo, $this->config->get('payment_hpjwechat_order_succeed_status_id'), $message, true);
                }
                $this->cart->clear();
                unset($this->session->data['order_id']);
                $this->session->data['cart']=array();
                $this->_redirect($this->url->link('checkout/success', '', 'SSL'));
                return;
            }
            
            if(method_exists($this->model_checkout_order,'confirm')){
                $order_info = $this->model_checkout_order->getOrder($OrderNo);
                if ($order_info && $order_info['order_status_id']) {
                    $this->model_checkout_order->update($OrderNo, $this->config->get('payment_hpjwechat_order_failed_status_id'), $message, true);
                }else{
                    $this->model_checkout_order->confirm($OrderNo, $this->config->get('payment_hpjwechat_order_failed_status_id'), $message, true);
                }
        
            }else{
                $this->model_checkout_order->addOrderHistory($OrderNo, $this->config->get('payment_hpjwechat_order_failed_status_id'), $message, true);
            }
        
            $this->_redirect($this->url->link('checkout/checkout', '', 'SSL'));
           
        } catch (Exception $e) {
            $msg =  "errcode:{$e->getCode()},errmsg:{$e->getMessage()}";
            $data=array();
            
            $data['text_wait'] = '3秒后跳转支付页面...';
            $data['Your_BillNo'] = $data['text_billno'] = $order_id;
            $data['text_failure_wait']='3秒后跳转支付页面...';
            $data['title']=$data['heading_title'] = $msg;
            $data['text_response']  = $msg;
            $data['text_failure'] = $msg;
            $data['continue'] = $this->url->link('checkout/checkout', '', 'SSL');
            $data['header'] = $this->load->controller('common/header');
            $data['column_left'] = $this->load->controller('common/column_left');
            $data['column_right'] = $this->load->controller('common/column_right');
            $data['footer'] = $this->load->controller('common/footer');
            $data['header'] = $this->load->controller('common/header');
            $data['column_left'] = $this->load->controller('common/column_left');
            $data['footer'] = $this->load->controller('common/footer');
            
            $this->response->setOutput($this->load->view('extension/payment/hpireturns', $data));
        }
    }
    
    public function notify(){
        $this->load->model('checkout/order');
        $this->language->load('extension/payment/hpjwechat');
    
        $appid              = $this->config->get('payment_hpjwechat_appid');//测试账户，仅支持一元内支付
        $appsecret          = $this->config->get('payment_hpjwechat_appsecret');//测试账户，仅支持一元内支付
        $order_prefix       = $this->config->get('payment_hpjwechat_order_prefix');
        
        $my_plugin_id       = 'oc_v3_wechat';
        
        $data = $_POST;
        foreach ($data as $k=>$v){
            $data[$k] = stripslashes($v);
        }
        
        if(!isset($data['hash'])||!isset($data['trade_order_id'])){
            echo 'failed';exit;
        }
        
        //自定义插件ID,请与支付请求时一致
        if(isset($data['plugins'])&&$data['plugins']!=$my_plugin_id){
            echo 'failed';exit;
        }
        
        //APP SECRET
        $hash =$this->generate_xh_hash($data,$appsecret);
        if($data['hash']!=$hash){
            //签名验证失败
            echo 'failed';exit;
        }
        
        //商户订单ID
        $trade_order_id =substr($data['trade_order_id'], strlen($order_prefix));
        $success_status = $this->config->get('payment_hpjwechat_order_succeed_status_id');
        
        $db = DB_PREFIX;
        $result =$this->db->query(
            "select *
            from `{$db}order`
            where order_id = '{$trade_order_id}'
            and order_status_id='{$success_status}'
            limit 1;");
        
        if($result->num_rows){
             echo 'success';exit;
        }
        
        if($data['status']=='OD'){
            $message = "Transaction Id:{$data['transaction_id']}";
            if(method_exists($this->model_checkout_order,'confirm')){
                $order_info =  $this->model_checkout_order->getOrder($trade_order_id);
                if ($order_info && $order_info['order_status_id']) {
                    $this->model_checkout_order->update($trade_order_id, $this->config->get('payment_hpjwechat_order_succeed_status_id'), $message, true);
                }else{
                    $this->model_checkout_order->confirm($trade_order_id, $this->config->get('payment_hpjwechat_order_succeed_status_id'), $message, true);
                }
            
            }else{
                $this->model_checkout_order->addOrderHistory($trade_order_id, $this->config->get('payment_hpjwechat_order_succeed_status_id'), $message, true);
            }
        }
        //以下是处理成功后输出，当支付平台接收到此消息后，将不再重复回调当前接口
        echo 'success';
        exit;
    }
    
    public function send()
    {
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/hpjwechat');
        $this->language->load('extension/payment/hpjwechat');
        $order_id = $this->session->data['order_id'];
        $json=array();
        if(empty($order_id)){
            $json['error'] = '购物车已清空，请重新购物！';
            $this->response->setOutput(json_encode($json));
            $this->response->addHeader('Content-Type: application/json');
            return;
        }
        
        $order = $this->model_checkout_order->getOrder($order_id);
        if(!$order){
            $json['error'] = '购物车已清空，请重新购物！';
            $this->response->setOutput(json_encode($json));
            $this->response->addHeader('Content-Type: application/json');
            return;
        }
        
        $currency = $order['currency_code'];
        $order_prefix = $this->config->get('payment_hpjwechat_order_prefix');
        $exchange_rate = $this->config->get('payment_hpjwechat_exchange_rate');
      	if($exchange_rate<=0){
        	$exchange_rate=1;
        }
        $amount = round($this->currency->format($order['total'], $currency, $order['currency_value'], FALSE),2);
      	$amount = round($amount*$exchange_rate,2); 
        
        $products = $this->cart->getProducts();
        if(!$products){
            $json['error'] = '购物车已清空，请重新购物！';
            $this->response->setOutput(json_encode($json));
            $this->response->addHeader('Content-Type: application/json');
            return;
        }
        
        $title = '';
        foreach ($products as $product) {
            if(!empty($title)){
                $title.='...';
                break;
            }
            $title.=$product['name'];
        }
        
        $return_url = $this->url->link('extension/payment/hpjwechat/returns', '', 'SSL');
        $return_url .= (strpos($return_url, '?')===false?'?':'&').'order_id='.$order_prefix.$order_id.'&sign='.md5(time().'AUYVBAIWOURVB');
        
        $data=array(
            'version'   => '1.1',//固定值，api 版本，目前暂时是1.1
            'lang'       => 'zh-cn', //必须的，zh-cn或en-us 或其他，根据语言显示页面
            'plugins'   => 'oc_v3_wechat',//必须的，根据自己需要自定义插件ID，唯一的，匹配[a-zA-Z\d\-_]+
            'appid'     => $this->config->get('payment_hpjwechat_appid'), //必须的，APPID
            'trade_order_id'=> $order_prefix.$order_id, //必须的，网站订单ID，唯一的，匹配[a-zA-Z\d\-_]+
            'payment'   => 'wechat',//必须的，支付接口标识：wechat(微信支付接口)|wechat(微信支付接口)
            'total_fee' => $amount,//人民币，单位精确到分(测试账户只支持0.1元内付款)
            'title'     => $title, //必须的，订单标题，长度32或以内
            'time'      => time(),//必须的，当前时间戳，根据此字段判断订单请求是否已超时，防止第三方攻击服务器
        		'is_app'=>self::is_app_client()?'Y':'N',
        		'notify_url'=>  $this->url->link('extension/payment/hpjwechat/notify', '', 'SSL'), //必须的，支付成功异步回调接口
            'return_url'=>  $return_url,//必须的，支付成功后的跳转地址
            'callback_url'=>$this->url->link('checkout/checkout', '', 'SSL'),//必须的，支付发起地址（未支付或支付失败，系统会会跳到这个地址让用户修改支付信息）
            'nonce_str' => str_shuffle(time())//必须的，随机字符串，作用：1.避免服务器缓存，2.防止安全密钥被猜测出来
        );
        
        $data['hash']     = $this->generate_xh_hash($data,$this->config->get('payment_hpjwechat_appsecret'));
       
        $url              = $this->config->get('payment_hpjwechat_transaction_url').'/payment/do.html';
        
        try {
            $response     = $this->http_post($url, json_encode($data));
            $result       = $response?json_decode($response,true):null;
            if(!$result){
                throw new Exception('Internal server error',500);
            }
             
            $hash         = $this->generate_xh_hash($result,$this->config->get('payment_hpjwechat_appsecret'));
            if(!isset( $result['hash'])|| $hash!=$result['hash']){
                throw new Exception(__('Invalid sign!'),40029);
            }
        
            if($result['errcode']!=0){
                throw new Exception($result['errmsg'],$result['errcode']);
            }
            //$this->cart->clear();
           unset($this->session->data['order_id']);
           // $this->session->data['cart']=array();
            $json['success'] =$result['url'];
        } catch (Exception $e) {
            $json['error'] = "errcode:{$e->getCode()},errmsg:{$e->getMessage()}";
        }
        
        $this->response->setOutput(json_encode($json));
        $this->response->addHeader('Content-Type: application/json');
    }
    public static function is_app_client(){
    	if(!isset($_SERVER['HTTP_USER_AGENT'])){
    		return false;
    	}
    	
    	$u=strtolower($_SERVER['HTTP_USER_AGENT']);
    	if($u==null||strlen($u)==0){
    		return false;
    	}
    	
    	preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/',$u,$res);
    	
    	if($res&&count($res)>0){
    		return true;
    	}
    	
    	if(strlen($u)<4){
    		return false;
    	}
    	
    	preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/',substr($u,0,4),$res);
    	if($res&&count($res)>0){
    		return true;
    	}
    	
    	$ipadchar = "/(ipad|ipad2)/i";
    	preg_match($ipadchar,$u,$res);
    	if($res&&count($res)>0){
    		return true;
    	}
    	
    	return false;
    }
    private function http_post($url,$data){
        if(!function_exists('curl_init')){
            throw new Exception('php未安装curl组件',500);
        }
    
        $protocol = (! empty ( $_SERVER ['HTTPS'] ) && $_SERVER ['HTTPS'] !== 'off' || $_SERVER ['SERVER_PORT'] == 443) ? "https://" : "http://";
        $siteurl= $protocol.$_SERVER['HTTP_HOST'];
    
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch,CURLOPT_URL, $url);
        curl_setopt($ch,CURLOPT_REFERER,$siteurl);
        curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
        curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,FALSE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        $response = curl_exec($ch);
        $httpStatusCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $error=curl_error($ch);
        curl_close($ch);
        if($httpStatusCode!=200){
            throw new Exception("invalid httpstatus:{$httpStatusCode} ,response:$response,detail_error:".$error,$httpStatusCode);
        }
         
        return $response;
    }
    private function generate_xh_hash(array $datas,$hashkey){
        ksort($datas);
        reset($datas);
         
        $pre =array();
        foreach ($datas as $key => $data){
            if(is_null($data)||$data===''){continue;}
            if($key=='hash'){
                continue;
            }
            $pre[$key]=stripslashes($data);
        }
         
        $arg  = '';
        $qty = count($pre);
        $index=0;
         
        foreach ($pre as $key=>$val){
            $arg.="$key=$val";
            if($index++<($qty-1)){
                $arg.="&";
            }
        }
         
        return md5($arg.$hashkey);
    }

    /**
     * 抛出错误
     */
    private function throw_err($order_id='订单编号未知!!'){
        $data=array();
        $data['text_wait'] = '3秒后跳转支付页面...';
        $data['Your_BillNo'] = $data['text_billno'] = $order_id;
        $data['text_failure_wait']='3秒后跳转支付页面...';
        $data['title']=$data['heading_title'] = '订单信息错误！';
        $data['text_response']  = '订单信息错误！';
        $data['text_failure'] = '订单信息错误！';
        $data['continue'] = $this->url->link('checkout/checkout', '', 'SSL');
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['column_right'] = $this->load->controller('common/column_right');
        $data['footer'] = $this->load->controller('common/footer');
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');
        $this->response->setOutput($this->load->view('extension/payment/hpireturns', $data));
        return;

    }
}